
{$G+}
Unit DosMem;

Interface

Const
	Verbose: Boolean = False;
	DosMemDebug: Boolean = True;
	LastAlloc: PChar = Nil;
Const
	HC: Array[0..15]Of Char = '0123456789ABCDEF';

Function FreeMem: LongInt;
Procedure Size(l: LongInt);
Procedure AllocMem(Descr: PChar; Var D; w: Word);
Procedure UnAllocMem(Var s);
Function Resize(Var s; w: Word): Integer;

Const
	MemBlocksAllocated: LongInt = 0;

Const
	MaxMemBlock = 355;

Var
	MemBlocks: Record
		Sig: Array[0..3]Of Char;
		Dat: Array[-1..MaxMemBlock]Of Record s: PChar; Seg: Word End
	End;

Function Debugging: Boolean;

Implementation

{$IFNDEF MSDOS}
Function MemAllocateBlock(HeapHandle, Size, Attributes: Word;
													EventProc: Pointer; var Selector: Word): Integer;
													Far; External 'RTM' Index $0005;

Function MemFreeBlock(Selector: Word): Integer;
													Far; External 'RTM' Index $0006;

Function MemResizeBlock(Selector: Word; Size: Word): Integer;
													Far; External 'RTM' Index $0007;

Function MemGetBlockSize(Selector: Word; Var Size: Longint): Integer;
													Far; External 'RTM' Index $0014;
{$ENDIF}


Function FreeMem: LongInt; Assembler;
Asm
{$IFNDEF MSDOS}
	push 2
	push 0
	call MemQueryFreeMem
{$ELSE}
	mov ah, 48h
	mov bx, -1
	int 21h
	push ax
	 push bx
    mov ah, 59h { Get extended error information }
		xor bx, bx
		int 21h
	 pop bx
	pop ax
	mov ax, bx
	mov dx, ax
	shl ax, 4
	shr dx, 12
{$ENDIF}
End;

Function Debugging: Boolean;
Begin
	Debugging := Verbose And(Mem[Seg0040:$49]And 127=3){$IFNDEF DOSLYHYT}And Not ModeX{$ENDIF}
End;

Procedure Size(l: LongInt);
Begin
	If(l<1000)Or((l>2000)And(l<9800))Then Write(l,' bytes')
	Else If l<1300 Then Write('about kbyte')
	Else If l<1200000 Then Write((l+512)Shr 10,' kbytes')
	Else
		Write(l Shr 20, '.',(l Div 104857)Mod 10, ' Mbytes')
End;

{Param=-1 = no param}
Procedure Warning(Where: PChar; Param, Code: LongInt);
Begin
	Write(#13^J'Warning: ',Where,'(');
	If Param<>-1 Then Write(Param);
	WriteLn(
		') returned non-zero code ',Code,#13^J+
		'Memory manager status: Free mem: ',FreeMem,
		'; Blocks allocated: ',MemBlocksAllocated,#10)
End;

{$IFDEF MSDOS}
Function MemAllocateBlock(HeapHandle: Word; Size: LongInt;
													Attributes: Word; EventProc: Pointer;
													Var Selector: Word): Integer;
													Assembler;
Asm
	mov ax, Size.word[0]
	mov dx, Size.word[2]
	mov cx, 4
	call LongShr
	mov bx, ax
	mov ah, 48h
	int 21h
	jc @1
	les di, Selector
	mov word ptr es:[di], ax
	xor ax, ax
@1:
End;
{$ENDIF}

Procedure AllocMem(Descr: PChar; Var D; w: Word);
Var
	s: Word;
	i: Integer;
Label QuitError, MakeError, Quittah, Retry;
Begin
	If @D = Nil Then
	Begin
		ErrorInfo := 'AllocMem()';
		Asm
			mov ax, 204
			jmp QuitError
		End
	End;
	LastAlloc := Descr;
Quittah:
	Pointer(D) := Nil;
	If w=0 Then Exit;
Retry:
	i := MemAllocateBlock(
		0, LongInt(w)Shl 4, gmem_Moveable Or gmem_Discardable,
		Nil, PtrRec(Pointer(D)).Seg);
	s := PtrRec(Pointer(D)).Seg;
	If i <> 0 Then
	Begin
		Warning('MemAllocateBlock', LongInt(w)Shl 4, i);
		If @HeapError = Nil Then Goto MakeError;
		Case HeapError(w Shl 4)Of
			2: Goto Retry;
			1: Begin w := 0; Goto Quittah End;
			Else
MakeError:
				ErrorInfo := 'AllocMem()';
				Asm
					mov ax, 203
QuitError:mov sp, bp
					pop bp
					jmp HaltError
				End
		End
	End;

	For i := 0 To High(MemBlocks.Dat)Do
		If MemBlocks.Dat[i].s = Nil Then
		Begin
			MemBlocks.Dat[i].s := Descr;
			MemBlocks.Dat[i].Seg := s;
			If Debugging And(Descr^ <> #0)And DosMemDebug Then
			Begin
				Write('Allocated ');
				Size(LongInt(w)Shl 4);
				Write(' for ',Descr,': ',
					HC[Hi(s)Shr 4],
					HC[Hi(s)And 15],
					HC[Lo(s)Shr 4],
					HC[Lo(s)And 15]);
				Write(':0000'^M^J)
			End;
			Break
		End;

	Inc(MemBlocksAllocated)
End;

{$IFDEF MSDOS}
Function MemFreeBlock(Selector: Word): Integer; Assembler;
Asm
	mov ah, 49h
	mov es, Selector
	int 21h
	jc @1
	xor ax, ax
@1:
End;
{$ENDIF}

Procedure UnAllocMem(Var s);
Var i: Integer;
Begin
	If Pointer(s)=Nil Then Exit;
	For i := 0 To High(MemBlocks.Dat)Do
		If(MemBlocks.Dat[i].s <> Nil)And
			 (MemBlocks.Dat[i].Seg = Seg(PChar(s)^))Then
		Begin
			If Debugging And(MemBlocks.Dat[i].s^ <> #0)And DosMemDebug Then
				WriteLn('Freed ',MemBlocks.Dat[i].s);
			MemBlocks.Dat[i].s := Nil
		End;

	i := MemFreeBlock(Seg(PChar(s)^));
	If i <> 0 Then
		Warning('MemFreeBlock', -1, i);

	Dec(MemBlocksAllocated)
End;

{$IFDEF MSDOS}
Function MemResizeBlock(Selector: Word; Size: LongInt): Integer; Assembler;
Asm
	mov ax, Size.word[0]
	mov dx, Size.word[2]
	mov cx, 4
	call LongShr
	mov bx, ax

	mov es, Selector
	mov ah, 4Ah
	int 21h
	jc @1
	xor ax, ax
@1:
End;
{$ENDIF}

Function Resize(Var s; w: Word): Integer;
Var i: Integer;
Begin
	For i := 0 To High(MemBlocks.Dat)Do
		If(MemBlocks.Dat[i].s <> Nil)And
			 (MemBlocks.Dat[i].Seg = Seg(PChar(s)^))Then
			If Debugging And(MemBlocks.Dat[i].s^ <> #0)And DosMemDebug Then
			Begin
				Write('Shrunk ',MemBlocks.Dat[i].s,' to ');
				Size(LongInt(w)Shl 4);
				WriteLn
			End;
	i := MemResizeBlock(PtrRec(Pointer(s)).Seg, LongInt(w)Shl 4);
	{$IFNDEF MSDOS}
	{Dossissa tm kun ei ole mikn kummallisuus}
	If i <> 0 Then
		Warning('MemResizeBlock', LongInt(w)Shl 4, i);
	{$ENDIF}
	Resize := w
End;

Var
	OldExit: Procedure;

Procedure DoneMem; Far;
Var a: Integer; p: PChar;
Begin
	ExitProc := OldExit;

	For a := 0 To High(MemBlocks.Dat)Do
		If MemBlocks.Dat[a].s <> Nil Then
		Begin
			p := Ptr(MemBlocks.Dat[a].Seg, 0);
			UnAllocMem(p)
		End
End;

Procedure InitMem;
Begin
	OldExit := ExitProc;
	ExitProc := DoneMem;

	MemW[PrefixSeg:$FC] := Ofs(MemBlocks);
	MemW[PrefixSeg:$FE] := Seg(MemBlocks);

	PLongInt(@MemBlocks.Sig)^ := $546D654D;

	{ - system unit heap manager does this already.
	FillChar(MemBlocks.Dat, SizeOf(MemBlocks.Dat), 0);}
	{$IFDEF MSDOS}
	{To disallocate this fails under DPMI}
	MemBlocks.Dat[0].s := 'my environment variable table';
	MemBlocks.Dat[0].Seg := MemW[PrefixSeg:$2C];
	{$ENDIF}

	MemBlocks.Dat[-1].s := 'program';
	MemBlocks.Dat[-1].Seg := PrefixSeg
End;

Begin
	InitMem
End.
