Unit Spawno;

Interface

Const
  (* symbolic constants for specifying permissible swap locations *)
  (* add/or together the desired destinations *)
  swap_disk = 0;
  swap_xms = 1;
  swap_ems = 2;
  swap_ext = 4;
  swap_all = $FF;    (* swap to any available destination *)

  (* error codes *)
  enotfound = 2;
  enopath = 3;
  eaccess = 5;
  enomem = 8;
  e2big = 20;
  ewritefault = 29;

Var
	SpawnError: Integer; (* error code when SPAWN returns -1 *)

Function Spawn(Prog, Args: String; EnvSeg: Integer): Integer;

Procedure InitSpawn(Dirs: String; Types, MinRes, ResStack: Integer);
				(* MinRes   = minimum number of paragraphs to keep resident
					 ResStack = minimum paragraphs of stack to keep resident
											(0 = no change)
				 *)

Implementation

{$L SPAWNTP.OBJ}

Function Spawn(Prog, Args: String; EnvSeg: Integer): Integer; External;
Procedure InitSpawn(Dirs: String; Types, MinRes, ResStack: Integer); External;

End.
